test_that("plot_effect works", {
  expect_error(
    plot_effects(sgb_model = "sgb"),
    "Model must be of class mboost"
  )
  library(dplyr)
  library(mboost)
  set.seed(1)
  df <- data.frame(
    x1 = rnorm(100), x2 = rnorm(100), x3 = rnorm(100),
    x4 = rnorm(100), x5 = runif(100)
  )
  df <- df %>%
    mutate_all(function(x) {
      as.numeric(scale(x))
    })
  df$y <- df$x1 + df$x4 + df$x5
  group_df <- data.frame(
    group_name = c(1, 1, 1, 2, 2),
    var_name = c("x1", "x2", "x3", "x4", "x5")
  )
  sgb_formula <- as.formula(create_formula(alpha = 0.3, group_df = group_df, intercept = T))
  sgb_model <- mboost(formula = sgb_formula, data = df)
  expect_error(plot_effects(sgb_model = sgb_model, prop = 1.2), "prop must be between zero and one")
  expect_error(plot_effects(sgb_model = sgb_model, prop = -1), "prop must be between zero and one")
  expect_message(plot_effects(sgb_model = sgb_model, n_predictors = 1, max_char_length = 20))
})

test_that("get_coef works", {
  expect_error(
    get_varimp(sgb_model = "sgb"),
    "Model must be of class mboost"
  )
  library(dplyr)
  library(mboost)
  set.seed(1)
  df <- data.frame(
    x1 = rnorm(100), x2 = rnorm(100), x3 = rnorm(100),
    x4 = rnorm(100), x5 = runif(100)
  )
  df <- df %>%
    mutate_all(function(x) {
      as.numeric(scale(x))
    })
  df$y <- df$x1 + df$x4 + df$x5
  group_df <- data.frame(
    group_name = c(1, 1, 1, 2, 2),
    var_name = c("x1", "x2", "x3", "x4", "x5")
  )
  sgb_formula <- as.formula(create_formula(alpha = 0.3, group_df = group_df, intercept = T))
  sgb_model <- mboost(formula = sgb_formula, data = df)
  sgb_coefs <- get_coef(sgb_model = sgb_model)[[2]] %>% select(variable, effect)
  expect_equal(
    tibble(
      variable = c("(Intercept)", "x3", "x2", "x1", "x5", "x4"),
      effect = c(0.000, -0.006, -0.021, 0.226, 0.508, 0.569)
    ) %>%
      arrange(-abs(effect)),
    sgb_coefs %>%
      mutate(effect = round(effect, 3))
  )
})

test_that("create_formula works", {
  # library(stats)
  expect_error(
    create_formula(group_df = "group"),
    "group_df must be a data.frame"
  )
  expect_error(
    create_formula(alpha = "0.5"),
    "Mixing parameter alpha must be numeric"
  )
  expect_error(
    create_formula(alpha = -0.5),
    "Mixing parameter alpha must between zero and one"
  )
  expect_error(
    create_formula(alpha = 5),
    "Mixing parameter alpha must between zero and one"
  )
  expect_error(
    create_formula(group_df = data.frame(group = 1)),
    "group_name and var_name have to be columns of group_df"
  )
  group_df <-
    data.frame(
      group_name = c(1, 1, 2),
      var_name = c("x1", "x2", "x3")
    )
  expect_warning(create_formula(alpha = 0.5, group_df = group_df, blearner = "bbs"))
  expect_equal(
    create_formula(alpha = 0.5, group_df = group_df),
    y ~ bols(x1, df = 0.5, intercept = FALSE) +
      bols(x2, df = 0.5, intercept = FALSE) +
      bols(x3, df = 0.5, intercept = FALSE) +
      bols(x1, x2, df = 0.5, intercept = FALSE) +
      bols(x3, df = 0.5, intercept = FALSE),
    ignore_formula_env = TRUE
  )
  expect_equal(
    create_formula(alpha = 1, group_df = group_df),
    y ~ bols(x1, df = 1, intercept = FALSE) +
      bols(x2, df = 1, intercept = FALSE) +
      bols(x3, df = 1, intercept = FALSE),
    ignore_formula_env = TRUE
  )
  expect_equal(
    create_formula(alpha = 0, group_df = group_df),
    y ~ bols(x1, x2, df = 1, intercept = FALSE) + bols(x3, df = 1, intercept = FALSE),
    ignore_formula_env = TRUE
  )
  colnames(group_df) <- c("group", "var")
  expect_equal(
    create_formula(alpha = 0, group_df = group_df, group_name = "group", var_name = "var"),
    y ~ bols(x1, x2, df = 1, intercept = FALSE) + bols(x3, df = 1, intercept = FALSE),
    ignore_formula_env = TRUE
  )
})

test_that("plot path works", {
  library(dplyr)
  library(mboost)
  set.seed(10)
  beta <- c(
    rep(5, 5), c(5, -5, 2, 0, 0), rep(-5, 5),
    c(2, -3, 8, 0, 0), rep(0, (200 - 20))
  )
  X <- matrix(data = rnorm(20000, mean = 0, sd = 1), 100, 200)
  df <- data.frame(X) %>%
    mutate(y = X %*% beta + rnorm(100, mean = 0, sd = 1)) %>%
    mutate_all(function(x) {
      as.numeric(scale(x))
    })
  group_df <- data.frame(group_name = rep(1:40, each = 5), variable_name = colnames(df)[1:200])

  # Input data.frames
  sgb_formula <- create_formula(
    alpha = 0.4, group_df = group_df, outcome_name = "y", intercept = FALSE,
    group_name = "group_name", var_name = "variable_name",
  )
  labels(terms(sgb_formula))[[1]]
  labels(terms(sgb_formula))[[201]]

  sgb_model <- mboost(
    formula = sgb_formula, data = df,
    control = boost_control(nu = 1, mstop = 600)
  )
  plot_path(sgb_model[50])
})

test_that("get_varimp works", {
  expect_error(
    get_varimp(sgb_model = "sgb"),
    "Model must be of class mboost"
  )
  library(mboost)
  library(dplyr)
  set.seed(1)
  df <- data.frame(
    x1 = rnorm(100), x2 = rnorm(100), x3 = rnorm(100),
    x4 = rnorm(100), x5 = runif(100)
  )
  df <- df %>%
    mutate_all(function(x) {
      as.numeric(scale(x))
    })
  df$y <- df$x1 + df$x4 + df$x5
  group_df <- data.frame(
    group_name = c(1, 1, 1, 2, 2),
    var_name = c("x1", "x2", "x3", "x4", "x5")
  )

  sgb_formula <- as.formula(create_formula(alpha = 0.3, group_df = group_df))
  sgb_model <- mboost(formula = sgb_formula, data = df)
  sgb_varimp <- sgboost::get_varimp(sgb_model)
  expect_equal(is.data.frame(sgb_varimp$varimp), TRUE)
  expect_equal(is.data.frame(sgb_varimp$group_importance), TRUE)
  expect_equal(dim(sgb_varimp$group_importance)[2], 2)
  expect_equal(
    tibble(
      reduction = c(1.62, 0.588),
      blearner = c(
        "bols(x4, x5, intercept = FALSE, df = 0.7)",
        "bols(x1, intercept = FALSE, df = 0.3)"
      ),
      predictor = c("x4, x5", "x1"),
      selfreq = c(0.59, 0.41),
      type = c("group", "individual"),
      relative_importance = c(0.7332, 0.2668)
    ),
    sgb_varimp$varimp,
    tolerance = 0.011
  )
  expect_equal(
    tibble(
      type = c("group", "individual"),
      importance = c(0.7332, 0.2668)
    ),
    sgb_varimp$group_importance,
    tolerance = 0.011
  )
})
